/*======================================================================================================================
  (c) Copyright OMRON Europe BV 2016
  All Right Reserved
  OMRON Development & Engineering
  -----------------------------------------------------------------------------------------------------------------*//**

  This file is part of Omron Secure Boot (OSB).

  Omron Secure Boot (OSB) is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Omron Secure Boot (OSB) is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Omron Secure Boot (OSB).  If not, see <http://www.gnu.org/licenses/>.

  @file
  
  Contains app specific logic for unsealing the the secret AES key in TPM. It also implements higher level AES
  encryption/decryption logic.
*//*==================================================================================================================*/

#ifndef EXTENSIONS_APPLIC_INC_APP_AES_H_
#define EXTENSIONS_APPLIC_INC_APP_AES_H_

/*=== Include files ==================================================================================================*/
#include "types.h"

/*=== Constant definitions ===========================================================================================*/

/*=== Macro definitions ==============================================================================================*/

/*=== Type definitions for events ====================================================================================*/

/*=== Type definitions ===============================================================================================*/

/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/
  
/*=== Function declarations (Interface functions) ====================================================================*/
int appaes_loadSealKey(void);
int appaes_aes128DecryptEcb(void const * const input, void * const output, t_U32 const length);
int appaes_aes128DecryptCbc(void* const input, void * const output, t_U32 const length);
int appaes_seal(void* const input, void * const output, t_U32 const length);
t_U8* appaes_getSealKey(t_U16* const keySize);
//int appaes_storeAes128DecKey(char const * const decKeyStr, t_U8 const * const pcrIndex, int const pcrIndexLen);
int appaes_loadAes128DecKey(void);
void appaes_destroyKey(void);
void appaes_init(t_bool const hasTpm);

#endif
