/*======================================================================================================================
  (c) Copyright OMRON Europe BV 2016
  All Right Reserved
  OMRON Development & Engineering
  -----------------------------------------------------------------------------------------------------------------*//**
  @file
  
  Implements the application logic for storing the RSA key in the TPM and to retrieve it when verifying data
*//*==================================================================================================================*/

#ifndef EXTENSIONS_APPLIC_INC_APP_RSA_H_
#define EXTENSIONS_APPLIC_INC_APP_RSA_H_

/*=== Include files ==================================================================================================*/
#include "types.h"

/*=== Constant definitions ===========================================================================================*/

/*=== Macro definitions ==============================================================================================*/

/*=== Type definitions for events ====================================================================================*/

/*=== Type definitions ===============================================================================================*/

/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/
  
/*=== Function declarations (Interface functions) ====================================================================*/
//int apprsa_storeRsa(int rsaIndex, const char* strE, const char* strN);
int apprsa_rsaVerify(t_U8* const input, int const inputLen, t_U8* const output, int* const outputLen);
void apprsa_destroyKey(void);
int apprsa_resetKeyIndex(void);
void apprsa_setKeyIndex(int const newKeyIndex);
int apprsa_nextKeyIndex(void);

#endif
