/*======================================================================================================================
  (c) Copyright OMRON Europe BV 2016
  All Right Reserved
  OMRON Development & Engineering
  -----------------------------------------------------------------------------------------------------------------*//**
  @file
  
  This file is part of Omron Secure Boot (OSB).

  Omron Secure Boot (OSB) is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Omron Secure Boot (OSB) is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Omron Secure Boot (OSB).  If not, see <http://www.gnu.org/licenses/>.

  Contains configuration data for the RSA encryption/decryption component
  
*//*==================================================================================================================*/

#ifndef EXTENSIONS_CNF_RSA_CFG_H_
#define EXTENSIONS_CNF_RSA_CFG_H_

/*=== Include files ==================================================================================================*/
#include "sha2.h"

/*=== Constant definitions ===========================================================================================*/
/**
 * Supported RSA key-len in bits.
 * Keep 1024 for now as this is extensively tested
 */
#define RSA_KEYLEN_BITS    (2048)
#define RSA_KEYLEN         (RSA_KEYLEN_BITS/8)

#if SHA512_DIGEST_LENGTH >= RSA_KEYLEN
    #error "The used hash size should be smaller then our RSA key length"
#endif

/*=== Macro definitions ==============================================================================================*/

/*=== Type definitions for events ====================================================================================*/

/*=== Type definitions ===============================================================================================*/

/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/
  
/*=== Function declarations (Interface functions) ====================================================================*/

#endif
