/*======================================================================================================================
  (c) Copyright OMRON Europe BV 2016
  All Right Reserved
  OMRON Development & Engineering
  -----------------------------------------------------------------------------------------------------------------*//**
  @file
  
  This file is part of Omron Secure Boot (OSB).

  Omron Secure Boot (OSB) is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Omron Secure Boot (OSB) is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Omron Secure Boot (OSB).  If not, see <http://www.gnu.org/licenses/>.

  <short description of the file in one sentence>. 

  [Optional extended description of the file. More details] 
  
  [@pre <pre-conditions and Environment restrictions>]
*//*==================================================================================================================*/

#ifndef EXTENSIONS_CONVARS_INC_CONVARS_H_
#define EXTENSIONS_CONVARS_INC_CONVARS_H_

/*=== Include files ==================================================================================================*/
#include "types.h"

/*=== Constant definitions ===========================================================================================*/
#define VAR_IDENT_STR       "@"
#define VAR_IDENT           '@'

/*=== Macro definitions ==============================================================================================*/

/*=== Type definitions for events ====================================================================================*/

/*=== Type definitions ===============================================================================================*/
typedef enum {
    CONVAR_OK = 0,
    CONVAR_EXISTS,
    CONVAR_RO,
    CONVAR_FULL,
    CONVAR_NOT_FOUND,
    CONVAR_VAL_WONT_FIT,
    CONVAR_PARAM_ERROR,
    CONVAR_INTERNAL_ERROR
} T_CONVAR_RESULT;
/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/
  
/*=== Function declarations (Interface functions) ====================================================================*/
void convars_init(void);
t_bool convars_isVar(t_U8 const * const cmdlChar);
T_CONVAR_RESULT convars_defVarStr(char const * const cmdlVarIdent,
                                  char const * const cmdlVarStrVal,
                                  t_bool const       asReadOnly,
                                  t_bool const       override);
T_CONVAR_RESULT convars_udefVar(char const * const cmdlVarIdent);
T_CONVAR_RESULT convars_defVarBin(char const * const  cmdlVarIdent,
                                  t_U8 const * const  cmdlVarBinVal,
                                  t_U16 const         cmdlVarBinValLength,
                                  t_bool const        asReadOnly,
                                  t_bool const        override);
T_CONVAR_RESULT convars_getVar(char const * const cmdlVarIdent, char** const varStrValue);
char* convars_getVarIdent(char const * const cmdlVarIdent, t_U8* const varIdentLength);
void convars_listReset(void);
t_bool convars_listNextItem(char** varIdent, char** varValue, t_bool* const isReadOnly);

#endif
