/*======================================================================================================================
  (c) Copyright OMRON Europe BV 2016
  All Right Reserved
  OMRON Development & Engineering
  -----------------------------------------------------------------------------------------------------------------*//**
  @file
  
  This file is part of Omron Secure Boot (OSB).

  Omron Secure Boot (OSB) is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Omron Secure Boot (OSB) is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Omron Secure Boot (OSB).  If not, see <http://www.gnu.org/licenses/>.

  Contains logic to implement RSA encryption (create) and decryption (verify) using the bigdigits library
  
*//*==================================================================================================================*/

#ifndef EXTENSIONS_RSA_INC_RSA_H_
#define EXTENSIONS_RSA_INC_RSA_H_

/*=== Include files ==================================================================================================*/
#include "types.h"
#include "bigdigits.h"
#include "rsa_cfg.h"

/*=== Constant definitions ===========================================================================================*/

/*=== Macro definitions ==============================================================================================*/

/*=== Type definitions for events ====================================================================================*/

/*=== Type definitions ===============================================================================================*/

/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/
  
/*=== Function declarations (Interface functions) ====================================================================*/
int rsa_create(DIGIT_T* const       mod,
               DIGIT_T* const       key,
               t_U8 const * const   input,
               int const            inputLen,
               t_U8* const          output,
               int* const           outputLen);
int rsa_verify(DIGIT_T* const       mod,
               DIGIT_T* const       key,
               t_U8 const * const   input,
               int const            inputLen,
               t_U8* const          output,
               int* const           outputLen);

#endif
