/*==========================================================================================================================================
  (c) Copyright OMRON Europe BV 2015
  All Right Reserved
  OMRON Development & Engineering
  -------------------------------------------------------------------------------------------------------------------------------------*//**
  @file
  
  <short description of the file in one sentence>. 

  [Optional extended description of the file. More details] 
  
  [@pre <pre-conditions and Environment restrictions>]
*//*======================================================================================================================================*/

#ifndef __SHA1_H_                         /* Only include this file once   */
#define __SHA1_H_                         /* If not defined, define it now */

/*=== Include files ======================================================================================================================*/
#include "types.h"

/*=== Constant definitions ===============================================================================================================*/
#define HASH_LENGTH 20
#define BLOCK_LENGTH 64

/*=== Macro definitions ==================================================================================================================*/

/*=== Type definitions ===================================================================================================================*/
typedef struct sha1nfo {
    t_U32 buffer[BLOCK_LENGTH/4];
    t_U32 state[HASH_LENGTH/4];
    t_U32 byteCount;
    t_U8 bufferOffset;
    t_U8 keyBuffer[BLOCK_LENGTH];
    t_U8 innerHash[HASH_LENGTH];
} sha1nfo;
/*=== Type definitions for events ========================================================================================================*/

/*=== Macro-function definitions =========================================================================================================*/

/*=== Inline-function definitions ========================================================================================================*/
  
/*=== Function declarations (Interface functions) ========================================================================================*/

/* header */





/* public API - prototypes - TODO: doxygen*/

/**const void *s1, const void *s2, size_t n)
 */
void sha1_init(sha1nfo *s);
/**
 */
void sha1_writebyte(sha1nfo *s, t_U8 data);
/**
 */
void sha1_write(sha1nfo *s, const char *data, t_U32 const len);
/**
 */
t_U8* sha1_result(sha1nfo *s);
/**
 */
void sha1_initHmac(sha1nfo *s, const t_U8* key, int keyLength);
/**
 */
t_U8* sha1_resultHmac(sha1nfo *s);
 
#endif
