/*======================================================================================================================
  (c) Copyright OMRON Europe BV 2016
  All Right Reserved
  OMRON Development & Engineering
  -----------------------------------------------------------------------------------------------------------------*//**
  @file

  Contains logic to implement RSA encryption (create) and decryption (verify) using the bigdigits library

*//*==================================================================================================================*/

#ifndef EXTENSIONS_TPM_ERROR_MESSAGES_H_
#define EXTENSIONS_TPM_ERROR_MESSAGES_H_

/*=== Include files ==================================================================================================*/

#include "types.h"
#include "tpm_error.h"

/*=== Constant definitions ===========================================================================================*/

/*=== Macro definitions ==============================================================================================*/

/*=== Type definitions for events ====================================================================================*/

/*=== Type definitions ===============================================================================================*/

/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/

/*=== Function declarations (Interface functions) ====================================================================*/

/*
 * Get descriptive message from returned error code
 * @param returnCode [in] Error code
 * return descriptive message
 */
char const* tpm_getErrorDescription(t_U32 const returnCode);

/*==================================================================================================================*/

#endif /* TPM_ERROR_MESSAGES_H_ */
