/*======================================================================================================================
  (c) Copyright OMRON Europe BV 2016
  All Right Reserved
  OMRON Development & Engineering
  -----------------------------------------------------------------------------------------------------------------*//**
  @file
  
  This file is part of Omron Secure Boot (OSB).

  Omron Secure Boot (OSB) is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Omron Secure Boot (OSB) is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Omron Secure Boot (OSB).  If not, see <http://www.gnu.org/licenses/>.

  Contains offsets for the TPM memory area
  
*//*==================================================================================================================*/

#ifndef EXTENSIONS_UTILS_INC_OFFSETS_H_
#define EXTENSIONS_UTILS_INC_OFFSETS_H_

/*=== Include files ==================================================================================================*/
#include "rsa_cfg.h"
#include "aes.h"

/*=== Constant definitions ===========================================================================================*/
#define RSA_KEY_E_OFFSET (0)
#define AES_KEY_OFFSET   (0)
#define AES_PCR_OFFSET   (AES_KEY_OFFSET + AES128_KEYLEN)

// Total PCR array length equal defined #pcrs multiplied by 2 for hex strings plus byte for array length
#define AES128_PCRLEN    ((TPM_PCRS+1)*2)

/*=== Macro definitions ==============================================================================================*/

/*=== Type definitions for events ====================================================================================*/

/*=== Type definitions ===============================================================================================*/

/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/
  
/*=== Function declarations (Interface functions) ====================================================================*/

#endif
