/*======================================================================================================================
  (c) Copyright OMRON Europe BV 2016
  All Right Reserved
  OMRON Development & Engineering
  -----------------------------------------------------------------------------------------------------------------*//**
  @file
  
  This file is part of Omron Secure Boot (OSB).

  Omron Secure Boot (OSB) is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Omron Secure Boot (OSB) is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Omron Secure Boot (OSB).  If not, see <http://www.gnu.org/licenses/>.

  Defines local types for extensions

*//*==================================================================================================================*/

#ifndef EXTENSIONS_UTILS_INC_TYPES_H_
#define EXTENSIONS_UTILS_INC_TYPES_H_

/*=== Include files ==================================================================================================*/

/*=== Constant definitions ===========================================================================================*/
#define OMN_EXIT_SUCCESS                (0)  // Note: Success should always be '0'. Do not change this
#define OMN_EXIT_FAILURE                (1)  // Note: Failure should always be '1'. Do not change this

/*=== Macro definitions ==============================================================================================*/

/*=== Type definitions for events ====================================================================================*/

/*=== Type definitions ===============================================================================================*/
#ifndef NULL
#define NULL ((void*)0)
#endif

typedef char* va_list;

typedef unsigned long long t_U64;
typedef unsigned long      t_U32;
typedef unsigned short     t_U16;
typedef unsigned char      t_U8;
typedef signed long        t_S32;
typedef signed short       t_S16;
typedef signed char        t_S8;
typedef char*              t_string;
typedef unsigned int       t_uintptr;
typedef unsigned           t_bool;

typedef t_U8               sha2_byte;
typedef t_U32              sha2_word32;
typedef t_U64              sha2_word64;

#ifndef FALSE
#define FALSE               ((t_bool)0)
#endif
#ifndef TRUE
#define TRUE                ((t_bool)1)
#endif

#define ISTRUE(x)               ((x) != FALSE)
#define ISFALSE(x)              ((x) == FALSE)

#ifdef __ANALYSE__
#define PACKED_BYTE_ALIGN(type)        (type)
#define INLINE
#else
#define PACKED_BYTE_ALIGN(type)        __attribute__ ((packed, aligned(1))) (type)
#define INLINE                          inline
#endif

#define ARRAY_SIZE(x)          (sizeof(x)/sizeof(x[0]))

/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/
  
/*=== Function declarations (Interface functions) ====================================================================*/

#endif
