/*======================================================================================================================
 (c) Copyright OMRON Europe BV 2016
 All Right Reserved
 OMRON Development & Engineering
 -----------------------------------------------------------------------------------------------------------------*//**
 @file

  This file is part of Omron Secure Boot (OSB).

  Omron Secure Boot (OSB) is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Omron Secure Boot (OSB) is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Omron Secure Boot (OSB).  If not, see <http://www.gnu.org/licenses/>.

 Contains supporting functions for other components

 *//*==================================================================================================================*/

#ifndef EXTENSIONS_UTILS_INC_KEYS_H_
#define EXTENSIONS_UTILS_INC_KEYS_H_

/*=== Include files ==================================================================================================*/
#include "types.h"

/*=== Constant definitions ===========================================================================================*/

/*=== Macro definitions ==============================================================================================*/
// round up macro
#define CEIL(x, y) ((x + (y - 1)) / y)
#ifndef DEBUG
#define GRUB_PANIC(s)   UPDATE_LOG_ERR_EXT(ERR_ASSERT_FAILED, s); getkey();
#else
#define GRUB_PANIC(s)   UPDATE_LOG_ERR_EXT(ERR_ASSERT_FAILED, s); for(;;);
#endif
#define GRUB_ASSERT(x)    if (!(x)) { GRUB_PANIC(""); }
#define GRUB_ASSERT_MESSAGE(x, y)    if (!(x)) { GRUB_PANIC(y); }

/*=== Type definitions for events ====================================================================================*/

/*=== Type definitions ===============================================================================================*/

/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/

/*=== Function declarations (Interface functions) ====================================================================*/
void utils_strReplace(char *buf, int const bufsize, char const* const strFind, char const* const strRep);
int utils_bufReplace(char* const pos, int const bufsize, int const skipBytes, char const* const bufRep, int const bufRepSize);
void utils_hexStrToByte(char const * const hexStr, t_U8* const byte);
void utils_byteToHexStr(t_U8 const byte, char* const hexStr);
void utils_printAsHexStr(t_U8 const* const data, int const len);
void utils_printKeyAsHexStr(t_U8 const* const key, int const keyLen);
void utils_printAsReverseHexStr(const t_U8* const data, int const len);
int utils_hexStrToArray(t_U8* const data, t_U32* const dataLen, char const * const hexstring);
int utils_hexStrToArrayReverse(t_U8* const data, t_U32* const dataLen, char const * const hexstring);
t_U32 const utils_pseudoRand(void);
int util_atoi(char const * const str);

#endif
