/*======================================================================================================================
  (c) Copyright OMRON Europe BV 2016
  All Right Reserved
  OMRON Development & Engineering
  -----------------------------------------------------------------------------------------------------------------*//**
  @file
  
  This file is part of Omron Secure Boot (OSB).

  Omron Secure Boot (OSB) is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Omron Secure Boot (OSB) is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Omron Secure Boot (OSB).  If not, see <http://www.gnu.org/licenses/>.

  Caches a file from disk into memory. The size of the file should be smaller than @p MAX_FILE_CACHE_SIZE otherwise
  an error-code is returned.

  The cache can be used to do file verification AND (on-the-fly) decryption to prevent Time-of-check-to-time-of-use
  attacks
*//*==================================================================================================================*/

#ifndef STAGE2_FILE_CACHE_H_
#define STAGE2_FILE_CACHE_H_

/*=== Include files ==================================================================================================*/
#include "types.h"

/*=== Constant definitions ===========================================================================================*/

/*=== Macro definitions ==============================================================================================*/

/*=== Type definitions for events ====================================================================================*/
typedef int (*T_ON_CACHE_FILLED)(t_U8* const /* startOfCache */, t_S32 const /* cacheSize */);

/*=== Type definitions ===============================================================================================*/

/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/
  
/*=== Function declarations (Interface functions) ====================================================================*/
void filecache_stack_init(t_U8* const stackBuffer, t_U32 const cacheMemSize);
void filecache_init(void* const cacheStartMemAddr, t_U32 const cacheMemSize);
int filecache_fill(char* const filename, T_ON_CACHE_FILLED const onCacheFilled);
int filecache_read(char* buf, int len);
void filecache_purge(void);

#endif
