/*======================================================================================================================
  (c) Copyright OMRON Europe BV 2016
  All Right Reserved
  OMRON Development & Engineering
  -----------------------------------------------------------------------------------------------------------------*//**
  @file
  
  This file is part of Omron Secure Boot (OSB).

  Omron Secure Boot (OSB) is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Omron Secure Boot (OSB) is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Omron Secure Boot (OSB).  If not, see <http://www.gnu.org/licenses/>.

  Implements logic to detect file encryption and decrypt a given file on-the-fly
  
*//*==================================================================================================================*/

#ifndef STAGE2_FILE_DECRYPT_H_
#define STAGE2_FILE_DECRYPT_H_

/*=== Include files ==================================================================================================*/
#include "shared.h"

/*=== Constant definitions ===========================================================================================*/

/*=== Macro definitions ==============================================================================================*/

/*=== Type definitions for events ====================================================================================*/

/*=== Type definitions ===============================================================================================*/
typedef int (*t_decryptEngine)(void const * const input, void * const output, t_U32 const length);

/*=== Macro-function definitions =====================================================================================*/

/*=== Inline-function definitions ====================================================================================*/
  
/*=== Function declarations (Interface functions) ====================================================================*/
int  filedecr_read(char* buf, int len);
int filedecr_evaluateAndProcess(t_U8* const cachedFile, t_S32 const cachedFileSize);
void filedecr_terminate(void);

#endif
