/* =====================================================================================================================
(c) Copyright OMRON Europe BV 2016
All Right Reserved 
OMRON Development & Engineering 
================================================================================================================== *//**
@file 

<short description of the file in one sentence>. 

[Optional extended description of the file. More details] 

@internal
*//* ================================================================================================================ */ 

/* ================ Global include files ============================================================================ */
#include "menu_items.h"
#include "shared.h"

/* ================ Sub-system include files ======================================================================== */

/* ================ Local constant definitions ====================================================================== */
#define MAX_ENTRY_TAGS      (64)

/* ================ Local macro definitions ========================================================================= */

/* ================ Local type definitions ========================================================================== */

/* ================ Local data definitions ========================================================================== */
typedef struct {
    char    tag[MAX_ENTRY_TAG_LENGTH];
    int     menuEntryNr;
    t_bool  inUse;
} T_MENU_ENTRY_TAG;

static T_MENU_ENTRY_TAG osbScriptEntries[MAX_ENTRY_TAGS] = { 0 };

/* ================ Local functions ================================================================================= */

/* ================ Global functions (Sub-system scope) ============================================================= */

/* ================ Global functions (Global system scope) ======================================================= *//**
@endinternal
*//* ================================================================================================================ */
/**
 *
 * @return
 */
int menuitems_getFirstMenuEntryNr(void)
{
    T_MENU_ENTRY_TAG const* mTag = osbScriptEntries;
    int                     idx  = 0;

    while (ISTRUE(mTag->inUse) && (mTag->menuEntryNr < 0)) {
        mTag++;
        idx++;
    }

    return (int)((idx < ARRAY_SIZE(osbScriptEntries) && ISTRUE(mTag->inUse)) ? idx : -1);
}

/**
 *
 * @param menuEntry
 * @return
 */
int menuitems_getCfgEntryFromMenuEntry(int const menuEntry)
{
    T_MENU_ENTRY_TAG const* mTag = osbScriptEntries;
    int                     idx  = 0;

    while (ISTRUE(mTag->inUse) && (mTag->menuEntryNr != menuEntry) && (idx < ARRAY_SIZE(osbScriptEntries))) {
        mTag++;
        idx++;
    }

    return (int)((idx < ARRAY_SIZE(osbScriptEntries) && ISTRUE(mTag->inUse)) ? idx : -1);
}

/**
 *
 * @param tag
 * @return
 */
int menuitems_getOsbScriptEntryNrByTag(char const * const tag)
{
    T_MENU_ENTRY_TAG const* mTag = osbScriptEntries;
    int                     idx  = 0;

    if (tag != NULL) {
        while (ISTRUE(mTag->inUse) && (strcmp(mTag->tag, tag) != 0) && (idx < ARRAY_SIZE(osbScriptEntries))) {
            mTag++;
            idx++;
        }
    } else {
        idx = ARRAY_SIZE(osbScriptEntries);
    }

    return (int)((idx < ARRAY_SIZE(osbScriptEntries) && ISTRUE(mTag->inUse)) ? idx : -1);
}

/**
 *
 * @return
 */
int menuitems_getMaxOsbScriptEntries(void)
{
    int                     idx  = 0;

    while (ISTRUE(osbScriptEntries[idx].inUse) && (idx < ARRAY_SIZE(osbScriptEntries))) {
        idx++;
    }

    return idx;
}

/**
 *
 * @param tag
 * @param menuEntryNo
 * @param configEntryNo
 * @return
 */
int menuitems_addEntry(char const * const tag, int const menuEntryNo, int const configEntryNo)
{
    int result = 1;

    if ((configEntryNo >= 0) && (configEntryNo < ARRAY_SIZE(osbScriptEntries))) {
        if (tag != NULL) {
            sstrcpy(osbScriptEntries[configEntryNo].tag, tag, sizeof(osbScriptEntries[configEntryNo].tag));
        } else {
            osbScriptEntries[configEntryNo].tag[0] = '\0';
        }
        osbScriptEntries[configEntryNo].menuEntryNr = menuEntryNo;
        osbScriptEntries[configEntryNo].inUse       = TRUE;
        result = 0;
    }
    return result;
}

/**
 *
 * @param potentialTag
 * @return
 */
t_bool menuitems_isTag(char const * const potentialTag)
{
    t_bool result;

    if ((potentialTag != NULL) &&
        (potentialTag[0] == TAG_IDENT) &&
        (potentialTag[1] != '\t') &&
        (potentialTag[1] != '\n') &&
        (potentialTag[1] != '\r') &&
        (potentialTag[1] != ' ')) {
        result = TRUE;
    } else {
        result = FALSE;
    }
    return result;
}
/* ================ End of file ===================================================================================== */
